package cours06;

public class ListeChaineI {

	/**
	 * @brief Créer une liste vide la liste est allouée en mémoire dynamique
	 * @return la liste crée (vide)
	 */
	public static ListeChaineD creer(Class bI) {
		ListeChaineD l = new ListeChaineD();
		l.ch = ChaineI.creer(bI);
		l.index = 0;
		l.longueur = 0;
		l.bI = bI;
		return l;
	}

	/**
	 * @brief Longueur de la liste la liste a été créée (cf. creer)
	 * @param[in] l : la liste testée
	 * @return longueur de la liste
	 */
	public static int longueur(ListeChaineD l) {
		return l.longueur;
	}

	/**
	 * @brief Déplacer la position courante à une position donnée dans la liste
	 * @param[in,out] l : la liste
	 * @param[in] i : la position de déplacement
	 */
	private static void deplacer(ListeChaineD l, int i) {
		//votre code ici (attention, vous ne renvoyez rien !)
	}

	/**
	 * @brief Lire un élément de liste
	 * @param[in] l : la liste
	 * @return l'item lu
	 * @pre 0<=i<longueur(l)
	 */
	public static Object lire(ListeChaineD l, int i) {
		deplacer(l, i);
		return (ChaineI.lire(l.ch));
	}

	/**
	 * @brief Ecrire un item dans la liste
	 * @param[in,out] l : la liste
	 * @param[in] i : position de l'élément à écrire
	 * @param[in] it : l'item
	 * @pre 0<=i<longueur(l)
	 */
	public static void ecrire(ListeChaineD l, int i, Object o) {
		deplacer(l, i);
		ChaineI.ecrire(l.ch, o);
	}

	/**
	 * @brief Insérer un élément dans une liste
	 * @param[in,out] l : la liste
	 * @param[in] i : la position avant laquelle l'élément est inséré
	 * @param[in] it : l'élément inséré
	 * @pre 0<=i<=longueur(l)
	 */
	public static void inserer(ListeChaineD l, int i, Object o) {
		deplacer(l, i);
		ChaineI.inserer(l.ch, o);
		l.longueur++;
	}

	/**
	 * @brief Supprimer un élément dans une liste
	 * @param[in,out] l : la liste
	 * @param[in] i : la position de l'élément à supprimer
	 * @pre 0<=i<longueur(l)
	 */
	public static void supprimer(ListeChaineD l, int i) {
		deplacer(l, i);
		ChaineI.supprimer(l.ch);
		l.index = i;
		l.longueur--;
	}

}
